unit WinForm;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data, Syncfusion.Windows.Forms.Grid;

type
  TWinForm = class(System.Windows.Forms.Form)
     SortDir: System.ComponentModel.ListSortDirection;

  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    Components: System.ComponentModel.Container;
    GridControl1: Syncfusion.Windows.Forms.Grid.GridControl;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure grid_QueryRowCount(sender: System.Object; e: Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs);
    procedure grid_QueryColCount(sender: System.Object; e: Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs);
    procedure grid_QueryCellInfo(sender: System.Object; e: Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs);
    procedure grid_SaveCellInfo(sender: System.Object; e: Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventArgs);
    procedure TWinForm_Load(sender: System.Object; e: System.EventArgs);
    procedure grid_CellClick(sender: System.Object; e: Syncfusion.Windows.Forms.Grid.GridCellClickEventArgs);
   {$ENDREGION}

    strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Private Declarations }
  public
    constructor Create;
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(TWinForm))]

implementation

{$AUTOBOX ON}

{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure TWinForm.InitializeComponent;
begin
  Self.GridControl1 := Syncfusion.Windows.Forms.Grid.GridControl.Create;
  (System.ComponentModel.ISupportInitialize(Self.GridControl1)).BeginInit;
  Self.SuspendLayout;
  // 
  // GridControl1
  // 
  Self.GridControl1.Anchor := (System.Windows.Forms.AnchorStyles((((System.Windows.Forms.AnchorStyles.Top 
    or System.Windows.Forms.AnchorStyles.Bottom) or System.Windows.Forms.AnchorStyles.Left) 
    or System.Windows.Forms.AnchorStyles.Right)));
  Self.GridControl1.Location := System.Drawing.Point.Create(32, 16);
  Self.GridControl1.Name := 'GridControl1';
  Self.GridControl1.Size := System.Drawing.Size.Create(492, 292);
  Self.GridControl1.SmartSizeBox := False;
  Self.GridControl1.TabIndex := 0;
  Self.GridControl1.Text := 'GridControl1';
  Include(Self.GridControl1.QueryColCount, Self.grid_QueryColCount);
  Include(Self.GridControl1.CellClick, Self.grid_CellClick);
  Include(Self.GridControl1.QueryRowCount, Self.grid_QueryRowCount);
  Include(Self.GridControl1.QueryCellInfo, Self.grid_QueryCellInfo);
  Include(Self.GridControl1.SaveCellInfo, Self.grid_SaveCellInfo);
  // 
  // TWinForm
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(544, 326);
  Self.Controls.Add(Self.GridControl1);
  Self.Name := 'TWinForm';
  Self.Text := 'WinForm';
  Include(Self.Load, Self.TWinForm_Load);
  (System.ComponentModel.ISupportInitialize(Self.GridControl1)).EndInit;
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure TWinForm.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor TWinForm.Create;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
  SortDir := ListSortDirection.Ascending;
end;

procedure TWinForm.grid_CellClick(sender: System.Object; e: Syncfusion.Windows.Forms.Grid.GridCellClickEventArgs);
begin
  if(e.RowIndex = 0) and (e.ColIndex = 3) then
  begin
        if (SortDir = ListSortDirection.Ascending ) then
              SortDir := ListSortDirection.Descending
        else
              SortDir := ListSortDirection.Ascending ;
  end;
end;

procedure TWinForm.TWinForm_Load(sender: System.Object; e: System.EventArgs);
begin
        //GridControl1.CellModels.Add('Test', GridStaticCellModel.Create(GridControl1.Model) );
        GridControl1.CellModels.Add('Test', GridSortColumnHeaderCellModel.Create(GridControl1.Model) );
end;

procedure TWinForm.grid_SaveCellInfo(sender: System.Object; e: Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventArgs);
begin

end;

procedure TWinForm.grid_QueryCellInfo(sender: System.Object; e: Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs);
begin
        if (e.RowIndex > 0) and (e.ColIndex > 0)  then
        begin
            e.Style.CellValue := e.RowIndex * 1000 + e.ColIndex;
        end
        else if(e.RowIndex = 0) and (e.ColIndex = 3) then
        begin
            e.Style.BackColor := Color.Red;
            e.Style.CellType := 'Test';
            e.Style.Tag := SortDir;
        end;
end;

procedure TWinForm.grid_QueryColCount(sender: System.Object; e: Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs);
begin

end;

procedure TWinForm.grid_QueryRowCount(sender: System.Object; e: Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs);
begin
  e.Count := 20;
  e.Handled := true;
end;

end.
